题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2544

Problem Description
在每年的校赛里,所有进入决赛的同学都会获得一件很漂亮的t-shirt。但是每当我们的工作人员把上百件的衣服从商店运回到赛场的时候,却是非常累的!所以现在他们想要寻找最短的从商店到赛场的路线,你可以帮助他们吗?

 
Input
输入包括多组数据。每组数据第一行是两个整数N、M(N<=100,M<=10000),N表示成都的大街上有几个路口,标号为1的路口是商店所在地,标号为N的路口是赛场所在地,M则表示在成都有几条路。N=M=0表示输入结束。接下来M行,每行包括3个整数A,B,C(1<=A,B<=N,1<=C<=1000),表示在路口A与路口B之间有一条路,我们的工作人员需要C分钟的时间走过这条路。
输入保证至少存在1条商店到赛场的路线。
 
Output
对于每组输入,输出一行,表示工作人员从商店走到赛场的最短时间
 
Sample Input
2 1
1 2 3
3 3
1 2 5
2 3 5
3 1 2
0 0
 
Sample Output
3
2
 
思路:套模板,记得是双向的
 #include <cstdio>
#include <queue>
#include <vector>
#include <cstring>
#include <algorithm>
using namespace std; struct edge {
int v, w;
edge(int v = , int w = ) : v(v), w(w) {}
}; int n, m, a, b, c;
int v[], d[]; vector<edge> G[]; void init() {
for(int i = ; i < ; i++) {
G[i].clear();
}
} void spfa() {
memset(v, , sizeof(v));
memset(d, 0x3f, sizeof(d));
d[] = , v[] = ;
queue<int> q;
q.push();
int x;
while(!q.empty()) {
x = q.front(), q.pop();
v[x] = ;
for(int i = ; i < G[x].size(); i++) {
int y = G[x][i].v, cost = G[x][i].w;
if(d[y] > d[x] + cost) {
d[y] = d[x] + cost;
if(!v[y]) {
q.push(y);
v[y] = ;
}
}
}
}
} int main() {
while(~scanf("%d%d", &n, &m)) {
if(n == && m == )
break;
init();
for(int i = ; i < m; i++) {
scanf("%d%d%d", &a, &b, &c);
G[a].push_back(edge(b, c));
G[b].push_back(edge(a, c));
}
spfa();
printf("%d\n",d[n]);
}
}

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1548

Problem Description
There is a strange lift.The lift can stop can at every floor as you want, and there is a number Ki(0 <= Ki <= N) on every floor.The lift have just two buttons: up and down.When you at floor i,if you press the button "UP" , you will go up Ki floor,i.e,you will go to the i+Ki th floor,as the same, if you press the button "DOWN" , you will go down Ki floor,i.e,you will go to the i-Ki th floor. Of course, the lift can't go up high than N,and can't go down lower than 1. For example, there is a buliding with 5 floors, and k1 = 3, k2 = 3,k3 = 1,k4 = 2, k5 = 5.Begining from the 1 st floor,you can press the button "UP", and you'll go up to the 4 th floor,and if you press the button "DOWN", the lift can't do it, because it can't go down to the -2 th floor,as you know ,the -2 th floor isn't exist.
Here comes the problem: when you are on floor A,and you want to go to floor B,how many times at least he has to press the button "UP" or "DOWN"?
 
Input
The input consists of several test cases.,Each test case contains two lines.
The first line contains three integers N ,A,B( 1 <= N,A,B <= 200) which describe above,The second line consist N integers k1,k2,....kn.
A single 0 indicate the end of the input.
 
Output
For each case of the input output a interger, the least times you have to press the button when you on floor A,and you want to go to floor B.If you can't reach floor B,printf "-1".
 
Sample Input
5 1 5
3 3 1 2 5
0
 
Sample Output
3
题意+思路:你在电梯上,第i 层能上升或下降ki层,但是不能低于第1层,不能高于第n层,且是单向的!!!故只需将第i层与它能到的层数之间设为1,其他都为inf即可,然后一遍spfa。
 #include <cstdio>
#include <cstring>
#include <queue>
#include <vector>
#include <algorithm>
using namespace std; int n, a, b, x;
int v[], d[]; struct edge {
int v, t;
edge(int v = , int t = ) : v(v), t(t) {}
}; vector<edge> G[]; void init() {
for(int i = ; i < ; i++) {
G[i].clear();
}
memset(v, , sizeof(v));
memset(d, 0x3f3f3f3f, sizeof(d));
} void spfa(int s) {
d[s] = , v[s] = ;
queue<int> q;
q.push(s);
int x;
while(!q.empty()) {
x = q.front(), q.pop();
v[x] = ;
for(int i = ; i < G[x].size(); i++) {
int y = G[x][i].v, z = G[x][i].t;
if(d[y] > d[x] + z) {
d[y] = d[x] + z;
if(!v[y]) {
v[y] = ;
q.push(y);
}
}
}
}
} int main() {
while(~scanf("%d", &n) && n) {
init();
scanf("%d%d", &a, &b);
for(int i = ; i <= n; i++) {
scanf("%d", &x);
if(i + x <= n) {
G[i].push_back(edge(i + x, ));
//G[i+x].push_back(edge(i,1));
}
if(i - x >= ) {
G[i].push_back(edge(i - x, ));
//G[i-x].push_back(edge(i, 1));
}
}
spfa(a);
printf("%d\n", d[b] >= 0x3f3f3f3f ? - : d[b]);
}
return ;
}

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3790

Problem Description
给你n个点,m条无向边,每条边都有长度d和花费p,给你起点s终点t,要求输出起点到终点的最短距离及其花费,如果最短距离有多条路线,则输出花费最少的。
 
Input
输入n,m,点的编号是1~n,然后是m行,每行4个数 a,b,d,p,表示a和b之间有一条边,且其长度为d,花费为p。最后一行是两个数 s,t;起点s,终点。n和m为0时输入结束。
(1<n<=1000, 0<m<100000, s != t)
 
Output
输出 一行有两个数, 最短距离及其花费。
 
Sample Input
3 2
1 2 5 6
2 3 4 5
1 3
0 0
 
Sample Output
9 11
思路:在求最短路时将每条道路间的最小花费进行更新即可。
代码实现如下:
 #include <cstdio>
#include <queue>
#include <vector>
#include <cstring>
#include <algorithm>
using namespace std; struct edge {
int v, l, cost;
edge(int v = , int l = , int cost = ) : v(v), l(l), cost(cost) {}
}; int n, m, a, b, e, f, s, t;
int v[], d[], c[]; vector<edge> G[]; void init() {
for(int i = ; i < ; i++) {
G[i].clear();
}
memset(v, , sizeof(v));
memset(d, 0x3f, sizeof(d));
memset(c, 0x3f, sizeof(c));
} void spfa(int s) {
d[s] = , v[s] = , c[s] = ;
queue<int> q;
q.push(s);
int x;
while(!q.empty()) {
x = q.front(), q.pop();
v[x] = ;
for(int i = ; i < G[x].size(); i++) {
int y = G[x][i].v, p = G[x][i].l, val = G[x][i].cost;
if(d[y] >= d[x] + p) {
if(d[y] == d[x] + p) {
c[y] = min(c[y], c[x] + val);
} else {
c[y] = c[x] + val;
}
d[y] = d[x] + p;
if(!v[y]) {
q.push(y);
v[y] = ;
}
}
}
}
} int main() {
while(~scanf("%d%d", &n, &m)) {
if(n == && m == )
break;
init();
for(int i = ; i < m; i++) {
scanf("%d%d%d%d", &a, &b, &e, &f);
G[a].push_back(edge(b, e, f));
G[b].push_back(edge(a, e, f));
}
scanf("%d%d", &s, &t);
spfa(s);
printf("%d %d\n", d[t], c[t]);
}
}

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2066

Problem Description
虽然草儿是个路痴(就是在杭电待了一年多,居然还会在校园里迷路的人,汗~),但是草儿仍然很喜欢旅行,因为在旅途中 会遇见很多人(白马王子,^0^),很多事,还能丰富自己的阅历,还可以看美丽的风景……草儿想去很多地方,她想要去东京铁塔看夜景,去威尼斯看电影,去阳明山上看海芋,去纽约纯粹看雪景,去巴黎喝咖啡写信,去北京探望孟姜女……眼看寒假就快到了,这么一大段时间,可不能浪费啊,一定要给自己好好的放个假,可是也不能荒废了训练啊,所以草儿决定在要在最短的时间去一个自己想去的地方!因为草儿的家在一个小镇上,没有火车经过,所以她只能去邻近的城市坐火车(好可怜啊~)。
 
Input
输入数据有多组,每组的第一行是三个整数T,S和D,表示有T条路,和草儿家相邻的城市的有S个,草儿想去的地方有D个;
接着有T行,每行有三个整数a,b,time,表示a,b城市之间的车程是time小时;(1=<(a,b)<=1000;a,b 之间可能有多条路)
接着的第T+1行有S个数,表示和草儿家相连的城市;
接着的第T+2行有D个数,表示草儿想去地方。
 
Output
输出草儿能去某个喜欢的城市的最短时间。
 
Sample Input
6 2 3
1 3 5
1 4 7
2 8 12
3 8 4
4 9 12
9 10 2
1 2
8 9 10
 
Sample Output
9
思路:多个起点的最短路,多次调用spfa即可,最后取她想去的地方的最短路中的最小值即可。
 #include <cstdio>
#include <queue>
#include <vector>
#include <cstring>
#include <algorithm>
using namespace std; const int maxn = ; int T, n, m, a, b, tt;
int v[maxn], d[maxn], mp[maxn][maxn]; vector<int> G[maxn]; void init() {
for(int i = ; i < maxn; i++) {
G[i].clear();
}
memset(v, , sizeof(v));
memset(d, 0x3f3f3f3f, sizeof(d));
memset(mp, 0x3f3f3f3f, sizeof(mp));
} void spfa(int s) {
v[s] = , d[s] = ;
queue<int> q;
q.push(s);
int x;
while(!q.empty()) {
x = q.front(), q.pop();
v[x] = ;
for(int i = ; i < G[x].size(); i++) {
int y = G[x][i], z = mp[x][y];
if(d[y] > d[x] + z) {
d[y] = d[x] + z;
if(!v[y]) {
q.push(y);
v[y] = ;
}
}
}
}
} int main() {
while(~scanf("%d%d%d", &T, &n, &m)) {
init();
for(int i = ; i < T; i++) {
scanf("%d%d%d", &a, &b, &tt);
G[a].push_back(b);
G[b].push_back(a);
mp[a][b] = min(mp[a][b], tt);
mp[b][a] = min(mp[b][a], tt);
}
for(int i = ; i < n; i++) {
scanf("%d", &a);
spfa(a);
}
int mm = 0x3f3f3f3f;
for(int i = ; i < m; i++) {
scanf("%d", &a);
mm = min(mm, d[a]);
}
printf("%d\n", mm);
}
}

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2112

Problem Description
经过锦囊相助,海东集团终于度过了危机,从此,HDU的发展就一直顺风顺水,到了2050年,集团已经相当规模了,据说进入了钱江肉丝经济开发区500强。这时候,XHD夫妇也退居了二线,并在风景秀美的诸暨市浬浦镇陶姚村买了个房子,开始安度晚年了。
这样住了一段时间,徐总对当地的交通还是不太了解。有时很郁闷,想去一个地方又不知道应该乘什么公交车,在什么地方转车,在什么地方下车(其实徐总自己有车,却一定要与民同乐,这就是徐总的性格)。
徐总经常会问蹩脚的英文问路:“Can you help me?”。看着他那迷茫而又无助的眼神,热心的你能帮帮他吗?
请帮助他用最短的时间到达目的地(假设每一路公交车都只在起点站和终点站停,而且随时都会开)。
 
Input
输入数据有多组,每组的第一行是公交车的总数N(0<=N<=10000);
第二行有徐总的所在地start,他的目的地end;
接着有n行,每行有站名s,站名e,以及从s到e的时间整数t(0<t<100)(每个地名是一个长度不超过30的字符串)。
note:一组数据中地名数不会超过150个。
如果N==-1,表示输入结束。
 
Output
如果徐总能到达目的地,输出最短的时间;否则,输出“-1”。
 
Sample Input
6
xiasha westlake
xiasha station 60
xiasha ShoppingCenterofHangZhou 30
station westlake 20
ShoppingCenterofHangZhou supermarket 10
xiasha supermarket 50
supermarket westlake 10
-1
 
Sample Output
50

Hint:
The best route is:
xiasha->ShoppingCenterofHangZhou->supermarket->westlake

虽然偶尔会迷路,但是因为有了你的帮助
**和**从此还是过上了幸福的生活。

――全剧终――

思路:本题由于每个节点它都是字符串,所以需要使用map进行映射,然后即可转换成一般的最短路问题。
 #include <map>
#include <cstdio>
#include <string>
#include <vector>
#include <queue>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std; int n, num, cost;
string s1, s2;
int v[], d[]; struct edge {
int v, t;
edge(int v = , int t = ) : v(v), t(t) {}
}; vector<edge> G[]; void init() {
memset(v, , sizeof(v));
memset(d, 0x3f3f3f3f, sizeof(d));
for(int i = ; i < ; i++) {
G[i].clear();
}
} void spfa(int s) {
d[s] = , v[s] = ;
queue<int> q;
q.push(s);
int x;
while(!q.empty()) {
x = q.front(), q.pop();
v[x] = ;
for(int i = ; i < G[x].size(); i++) {
int y = G[x][i].v, z = G[x][i].t;
if(d[y] > d[x] + z) {
d[y] = d[x] + z;
if(!v[y]) {
q.push(y);
v[y] = ;
}
}
}
}
} int main() {
while(~scanf("%d", &n) && (n != -)) {
cin >>s1 >>s2;
num = ;
init();
map<string, int> id;
id[s1] = num++;
id[s2] = num++;
int s = id[s1], e = id[s2];
for(int i = ; i < n; i++) {
cin >>s1 >> s2 >>cost;
if(!id.count(s1)) {
id[s1] = num++;
}
if(!id.count(s2)) {
id[s2] = num++;
}
G[id[s1]].push_back(edge(id[s2], cost));
G[id[s2]].push_back(edge(id[s1], cost));
}
spfa(s);
printf("%d\n", d[e] >= 0x3f3f3f3f ? - : d[e]);
}
}

最短路之spfa系列的更多相关文章

  1. 模板C++ 03图论算法 1最短路之单源最短路(SPFA)

    3.1最短路之单源最短路(SPFA) 松弛:常听人说松弛,一直不懂,后来明白其实就是更新某点到源点最短距离. 邻接表:表示与一个点联通的所有路. 如果从一个点沿着某条路径出发,又回到了自己,而且所经过 ...

  2. ACM/ICPC 之 最短路-Floyd+SPFA(BFS)+DP(ZOJ1232)

    这是一道非常好的题目,融合了很多知识点. ZOJ1232-Adventrue of Super Mario 这一题折磨我挺长时间的,不过最后做出来非常开心啊,哇咔咔咔 题意就不累述了,注释有写,难点在 ...

  3. POJ 2449Remmarguts' Date K短路模板 SPFA+A*

    K短路模板,A*+SPFA求K短路.A*中h的求法为在反图中做SPFA,求出到T点的最短路,极为估价函数h(这里不再是估价,而是准确值),然后跑A*,从S点开始(此时为最短路),然后把与S点能达到的点 ...

  4. ACM-最短路(SPFA,Dijkstra,Floyd)之最短路——hdu2544

    ***************************************转载请注明出处:http://blog.csdn.net/lttree************************** ...

  5. BZOJ_1614_ [Usaco2007_Jan]_Telephone_Lines_架设电话线_(二分+最短路_Dijkstra/Spfa)

    描述 http://www.lydsy.com/JudgeOnline/problem.php?id=1614 分析 类似POJ_3662_Telephone_Lines_(二分+最短路) Dijks ...

  6. 洛谷最短路计数SPFA

    题目描述 给出一个N个顶点M条边的无向无权图,顶点编号为1-N.问从顶点1开始,到其他每个点的最短路有几条. 输入输出格式 输入格式: 输入第一行包含2个正整数N,M,为图的顶点数与边数. 接下来M行 ...

  7. UESTC30-最短路-Floyd最短路、spfa+链式前向星建图

    最短路 Time Limit: 3000/1000MS (Java/Others) Memory Limit: 65535/65535KB (Java/Others) 在每年的校赛里,所有进入决赛的同 ...

  8. 最短路(spfa)

    http://acm.hdu.edu.cn/showproblem.php?pid=2544 最短路 Time Limit: 5000/1000 MS (Java/Others)    Memory ...

  9. 2018/1/28 每日一学 单源最短路的SPFA算法以及其他三大最短路算法比较总结

    刚刚AC的pj普及组第四题就是一种单源最短路. 我们知道当一个图存在负权边时像Dijkstra等算法便无法实现: 而Bellman-Ford算法的复杂度又过高O(V*E),SPFA算法便派上用场了. ...

随机推荐

  1. lintcode-167-链表求和

    167-链表求和 你有两个用链表代表的整数,其中每个节点包含一个数字.数字存储按照在原来整数中相反的顺序,使得第一个数字位于链表的开头.写出一个函数将两个整数相加,用链表形式返回和. 样例 给出两个链 ...

  2. lintcode-163-不同的二叉查找树

    163-不同的二叉查找树 给出 n,问由 1...n 为节点组成的不同的二叉查找树有多少种? 样例 给出n = 3,有5种不同形态的二叉查找树: 标签 卡特兰数 动态规划 思路 参考博客http:// ...

  3. Thread.Sleep(0)

    理解Thread.Sleep函数 我们可能经常会用到 Thread.Sleep 函数来使线程挂起一段时间.那么你有没有正确的理解这个函数的用法呢? 思考下面这两个问题: 1.假设现在是 2008-4- ...

  4. 织梦CMS建站入门学习(一)

    一.下载与安装. 首先到织梦官网下载软件,可选择UTF8或GBK不同编码格式,如果电脑没有PHP环境,还要下载dede自带的PHP环境软件. 将软件中的upload文件夹内容复制到WWW文件夹下,然后 ...

  5. ubuntu 只有客人会话登录(第一次深刻感受文件权限的威力 )

    为了测试docker的挂载权限,把宿主机的/etc/passwd文件挂载到了虚机当中,进入虚机想看下能不能直接对我宿主机上的文件进行操作,把/etc/passwd删掉了最后十行...结果宿主机上的/e ...

  6. [C/C++] 大小端存储问题

    首先来看一下今天做的一道题: 解析: union 维护足够的空间来置放多个数据成员中的“一种”,而不是为每一个数据成员配置空间,在union 中所有的数据成员共用一个空间,同一时间只能储存其中一个数据 ...

  7. 【刷题】BZOJ 2179 FFT快速傅立叶

    Description 给出两个n位10进制整数x和y,你需要计算x*y. Input 第一行一个正整数n. 第二行描述一个位数为n的正整数x. 第三行描述一个位数为n的正整数y. Output 输出 ...

  8. 【刷题】BZOJ 2882 工艺

    Description 小敏和小燕是一对好朋友. 他们正在玩一种神奇的游戏,叫Minecraft. 他们现在要做一个由方块构成的长条工艺品.但是方块现在是乱的,而且由于机器的要求,他们只能做到把这个工 ...

  9. HDOJ(HDU).2191. 悼念512汶川大地震遇难同胞――珍惜现在,感恩生活 (DP 多重背包+二进制优化)

    HDOJ(HDU).2191. 悼念512汶川大地震遇难同胞――珍惜现在,感恩生活 (DP 多重背包+二进制优化) 题意分析 首先C表示测试数据的组数,然后给出经费的金额和大米的种类.接着是每袋大米的 ...

  10. 【BZOJ 4555】[Tjoi2016&Heoi2016]求和 多项式求逆/NTT+第二类斯特林数

    出处0.0用到第二类斯特林数的性质,做法好像很多,我打的是直接ntt,由第二类斯特林数的容斥公式可以推出,我们可以对于每一个i,来一次ntt求出他与所有j组成的第二类斯特林数的值,这个时候我们是O(n ...